Index: src/UIElements/CommandLineUI/Query/ElementsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/ElementsCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/ElementsCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 #include "World.hpp"
 
-CommandLineDialog::ElementsCommandLineQuery::ElementsCommandLineQuery(std::string title, std::string _description) :
-    Dialog::ElementsQuery(title, _description)
+CommandLineDialog::ElementsCommandLineQuery::ElementsCommandLineQuery(Parameter<std::vector<const element*> > &param, std::string title, std::string _description) :
+    Dialog::ElementsQuery(param, title, _description)
 {}
 
@@ -40,9 +40,11 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     vector<int> AllElements = CommandLineParser::getInstance().vm[getTitle()].as< vector<int> >();
+    vector<const element *> temp_elements;
     for (vector<int>::iterator ZRunner = AllElements.begin(); ZRunner != AllElements.end(); ++ZRunner) {
       temp = periode->FindElement(*ZRunner);
       ASSERT(temp != NULL, "Invalid element specified in ElementCommandLineQuery");
-      tmp.push_back(temp);
+      temp_elements.push_back(temp);
     }
+    tmp.set(temp_elements);
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::FileCommandLineQuery::FileCommandLineQuery(std::string title, std::string _description) :
-    Dialog::FileQuery(title, _description)
+CommandLineDialog::FileCommandLineQuery::FileCommandLineQuery(Parameter<boost::filesystem::path> &param, std::string title, std::string _description) :
+    Dialog::FileQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::FileCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as< boost::filesystem::path >();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as< boost::filesystem::path >());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/FilesCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/FilesCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/FilesCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::FilesCommandLineQuery::FilesCommandLineQuery(std::string title, std::string _description) :
-    Dialog::FilesQuery(title, _description)
+CommandLineDialog::FilesCommandLineQuery::FilesCommandLineQuery(Parameter<std::vector< boost::filesystem::path> > &param, std::string title, std::string _description) :
+    Dialog::FilesQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::FilesCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<boost::filesystem::path> >();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as< std::vector<boost::filesystem::path> >());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(std::string title, std::string _description) :
-    Dialog::IntQuery(title, _description)
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(Parameter<int> &param, std::string title, std::string _description) :
+    Dialog::IntQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::IntCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as<int>());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::IntsCommandLineQuery::IntsCommandLineQuery(std::string title, std::string _description) :
-    Dialog::IntsQuery(title, _description)
+CommandLineDialog::IntsCommandLineQuery::IntsCommandLineQuery(Parameter<std::vector<int> > &param, std::string title, std::string _description) :
+    Dialog::IntsQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::IntsCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(std::string title, std::string _description) :
-    Dialog::MoleculeQuery(title, _description)
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(Parameter<const molecule *> &param, std::string title, std::string _description) :
+    Dialog::MoleculeQuery(param, title, _description)
 {}
 
@@ -38,5 +38,5 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
-    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    tmp.set(World::getInstance().getMolecule(MoleculeById(IdxOfMol)));
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -29,6 +29,6 @@
 #include "World.hpp"
 
-CommandLineDialog::MoleculesCommandLineQuery::MoleculesCommandLineQuery(std::string title, std::string _description) :
-    Dialog::MoleculesQuery(title, _description)
+CommandLineDialog::MoleculesCommandLineQuery::MoleculesCommandLineQuery(Parameter<std::vector<const molecule *> > &param, std::string title, std::string _description) :
+    Dialog::MoleculesQuery(param, title, _description)
 {}
 
@@ -39,9 +39,11 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    std::vector<const molecule *> temp_molecules;
     for (std::vector<int>::iterator iter = IdxOfMol.begin(); iter != IdxOfMol.end(); ++iter) {
       temp = World::getInstance().getMolecule(MoleculeById(*iter));
       if (temp)
-        tmp.push_back(temp);
+        temp_molecules.push_back(temp);
     }
+    tmp.set(temp_molecules);
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 #include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
 
-CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::RandomNumberDistribution_ParametersCommandLineQuery(std::string title, std::string _description) :
-    Dialog::RandomNumberDistribution_ParametersQuery(title, _description)
+CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::RandomNumberDistribution_ParametersCommandLineQuery(Parameter<RandomNumberDistribution_Parameters> &param, std::string title, std::string _description) :
+    Dialog::RandomNumberDistribution_ParametersQuery(param, title, _description)
 {}
 
@@ -42,5 +42,7 @@
     std::stringstream text(stringtext);
 //    LOG(1, "INFO: Parameter set from CommandLine is '" << text.str() << "'");
-    text >> tmp;
+    RandomNumberDistribution_Parameters temp_params;
+    text >> temp_params;
+    tmp.set(temp_params);
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/RealSpaceMatrixCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/RealSpaceMatrixCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/UIElements/CommandLineUI/Query/RealSpaceMatrixCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,47 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BoxCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Actions/Values.hpp"
+#include "CommandLineUI/Query/CommandLineQuery.hpp"
+#include "CommandLineUI/CommandLineParser.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+
+CommandLineDialog::RealSpaceMatrixCommandLineQuery::RealSpaceMatrixCommandLineQuery(Parameter<RealSpaceMatrix> &param, std::string title, std::string _description) :
+    Dialog::RealSpaceMatrixQuery(param, title, _description)
+{}
+
+CommandLineDialog::RealSpaceMatrixCommandLineQuery::~RealSpaceMatrixCommandLineQuery()
+{}
+
+bool CommandLineDialog::RealSpaceMatrixCommandLineQuery::handle() {
+  RealSpaceMatrixValue temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as< RealSpaceMatrixValue >();
+    tmp.set(temp.toRealSpaceMatrix());
+    return true;
+  } else {
+    ELOG(1, "CommandLineUI parsing error: Missing symmetric box matrix for " << getTitle() << ".");
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(std::string title, std::string _description) :
-    Dialog::StringQuery(title, _description)
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(Parameter<std::string> &param, std::string title, std::string _description) :
+    Dialog::StringQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::StringCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as<string>();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as<string>());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(std::string title, std::string _description) :
-    Dialog::StringsQuery(title, _description)
+CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(Parameter<std::vector<std::string> > &param, std::string title, std::string _description) :
+    Dialog::StringsQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::StringsCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<std::string> >();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as< std::vector<std::string> >());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/UnsignedIntCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/UnsignedIntCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/UnsignedIntCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::UnsignedIntCommandLineQuery::UnsignedIntCommandLineQuery(std::string title, std::string _description) :
-    Dialog::UnsignedIntQuery(title, _description)
+CommandLineDialog::UnsignedIntCommandLineQuery::UnsignedIntCommandLineQuery(Parameter<unsigned int> &param, std::string title, std::string _description) :
+    Dialog::UnsignedIntQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::UnsignedIntCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as<unsigned int>();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as<unsigned int>());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,6 +25,6 @@
 #include "CodePatterns/Verbose.hpp"
 
-CommandLineDialog::UnsignedIntsCommandLineQuery::UnsignedIntsCommandLineQuery(std::string title, std::string _description) :
-    Dialog::UnsignedIntsQuery(title, _description)
+CommandLineDialog::UnsignedIntsCommandLineQuery::UnsignedIntsCommandLineQuery(Parameter<std::vector<unsigned int> > &param, std::string title, std::string _description) :
+    Dialog::UnsignedIntsQuery(param, title, _description)
 {}
 
@@ -33,5 +33,5 @@
 bool CommandLineDialog::UnsignedIntsCommandLineQuery::handle() {
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<unsigned int> >();
+    tmp.set(CommandLineParser::getInstance().vm[getTitle()].as< std::vector<unsigned int> >());
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -29,6 +29,6 @@
 #include "World.hpp"
 
-CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorQuery(title,_check, _description)
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(Parameter<Vector> &param, std::string title, bool _check, std::string _description) :
+    Dialog::VectorQuery(param, title,_check, _description)
 {}
 
@@ -40,9 +40,10 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     temp = CommandLineParser::getInstance().vm[getTitle()].as< VectorValue >();
-    tmp = temp.toVector();
-    if ((check) && (!World::getInstance().getDomain().isValid(tmp))) {
-      ELOG(1, "Vector " << tmp << " would be outside of box domain.");
+    Vector temp_vector = temp.toVector();
+    if ((check) && (!World::getInstance().getDomain().isValid(temp_vector))) {
+      ELOG(1, "Vector " << temp_vector << " would be outside of box domain.");
       return false;
     }
+    tmp.set(temp_vector);
     return true;
   } else {
Index: src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -29,6 +29,6 @@
 #include "World.hpp"
 
-CommandLineDialog::VectorsCommandLineQuery::VectorsCommandLineQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorsQuery(title,_check, _description)
+CommandLineDialog::VectorsCommandLineQuery::VectorsCommandLineQuery(Parameter<std::vector<Vector> > &param, std::string title, bool _check, std::string _description) :
+    Dialog::VectorsQuery(param, title,_check, _description)
 {}
 
@@ -40,11 +40,13 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     temporary = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<VectorValue> >();
+    std::vector<Vector> temp_vectors;
     for(std::vector<VectorValue>::iterator iter = temporary.begin(); iter != temporary.end(); ++iter) {
       temp = (*iter).toVector();
       if ((!check) || (World::getInstance().getDomain().isValid(temp)))
-        tmp.push_back(temp);
+        temp_vectors.push_back(temp);
       else
         ELOG(1, "Vector " << temp << " would be outside of box domain.");
     }
+    tmp.set(temp_vectors);
     return true;
   } else {
Index: src/UIElements/CommandLineUI/TypeEnumContainer.cpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 #include "Atom/atom.hpp"
-#include "Box.hpp"
 #include "LinearAlgebra/BoxVector.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
 #include "LinearAlgebra/Vector.hpp"
 #include "Element/element.hpp"
@@ -45,5 +45,5 @@
   TypeEnumMap[&typeid(void)] = NoneType;
   TypeEnumMap[&typeid(bool)] = BooleanType;
-  TypeEnumMap[&typeid(Box)] = BoxType;
+  TypeEnumMap[&typeid(RealSpaceMatrix)] = RealSpaceMatrixType;
   TypeEnumMap[&typeid(BoxVector)] = VectorType;
   TypeEnumMap[&typeid(Vector)] = VectorType;
Index: src/UIElements/CommandLineUI/TypeEnumContainer.hpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,5 +28,4 @@
   enum EnumOfTypes { NoneType,
         BooleanType,
-        BoxType,
         FileType,
         ListOfFilesType,
@@ -47,5 +46,6 @@
         ElementType,
         ListOfElementsType,
-        RandomNumberDistribution_ParametersType
+        RandomNumberDistribution_ParametersType,
+        RealSpaceMatrixType
   };
 
Index: src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp
===================================================================
--- src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,4 +28,6 @@
 #include "Actions/ActionTrait.hpp"
 #include "UIElements/CommandLineUI/CommandLineParser.hpp"
+#include "World.hpp"
+#include "WorldTime.hpp"
 
 #include "CommandLineParser_ActionRegistry_ConsistencyUnitTest.hpp"
@@ -45,5 +47,5 @@
 void CommandLineParser_ActionRegistry_ConsistencyTest::setUp()
 {
-  AR = ActionRegistry::getPointer();
+  CPPUNIT_ASSERT_NO_THROW(AR = ActionRegistry::getPointer());
   CLP = CommandLineParser::getPointer();
 };
@@ -54,4 +56,9 @@
   CommandLineParser::purgeInstance();
   ActionRegistry::purgeInstance();
+  // these come about because of the validators accessing them instantiated
+  // by ActionRegistry. In ActionRegistryUnitTest we used stubs for them but
+  // here we care whether default values are actually valid.
+  World::purgeInstance();
+  WorldTime::purgeInstance();
 };
 
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Dialog.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -26,6 +26,7 @@
 #include "CodePatterns/Verbose.hpp"
 
+#include "Parameters/ParameterExceptions.hpp"
+
 class Atom;
-class Box;
 class element;
 class RealSpaceMatrix;
@@ -65,5 +66,12 @@
   bool retval = true;
   for(iter=queries.begin(); iter!=queries.end(); iter++){
-    retval &= (*iter)->handle();
+    try {
+      retval &= (*iter)->handle();
+    } catch (ParameterException &e) {
+      if( const std::string *name=boost::get_error_info<ParameterName>(e) )
+        ELOG(1, "The following parameter value is not valid: " << *name << ".");
+      retval = false;
+      break;
+    }
     // if any query fails (is canceled), we can end the handling process
     if(!retval) {
@@ -78,5 +86,11 @@
   list<Query*>::iterator iter;
   for(iter=queries.begin(); iter!=queries.end(); iter++) {
-    (*iter)->setResult();
+    try {
+      (*iter)->setResult();
+    } catch (ParameterException &e) {
+      if( const std::string *name=boost::get_error_info<ParameterName>(e) )
+        ELOG(1, "The following parameter value is not valid: " << *name << ".");
+      break;
+    }
   }
 }
@@ -86,122 +100,124 @@
 }
 
-template <> void Dialog::query<void *>(const char *token, std::string description)
+template <> void Dialog::query<void *>(Parameter<void *> &param, const char *token, std::string description)
 {
   queryEmpty(token, description);
 }
 
-template <> void Dialog::query<bool>(const char *token, std::string description)
-{
-  queryBoolean(token, description);
-}
-
-template <> void Dialog::query<int>(const char *token, std::string description)
-{
-  queryInt(token, description);
-}
-
-template <> void Dialog::query< std::vector<int> >(const char *token, std::string description)
-{
-  queryInts(token, description);
-}
-
-template <> void Dialog::query<unsigned int>(const char *token, std::string description)
-{
-  queryUnsignedInt(token, description);
-}
-
-template <> void Dialog::query< std::vector<unsigned int> >(const char *token, std::string description)
-{
-  queryUnsignedInts(token, description);
-}
-
-template <> void Dialog::query<double>(const char *token, std::string description)
-{
-  queryDouble(token, description);
-}
-
-template <> void Dialog::query< std::vector<double> >(const char *token, std::string description)
-{
-  queryDoubles(token, description);
-}
-
-template <> void Dialog::query<std::string>(const char *token, std::string description)
-{
-  queryString(token, description);
-}
-
-template <> void Dialog::query< std::vector<std::string> >(const char *token, std::string description)
-{
-  queryStrings(token, description);
-}
-
-template <> void Dialog::query<const atom *>(const char *token, std::string description)
-{
-  queryAtom(token, description);
-}
-
-template <> void Dialog::query< std::vector<const atom *> >(const char *token, std::string description)
-{
-  queryAtoms(token, description);
-}
-
-template <> void Dialog::query<const molecule *>(const char *token, std::string description)
-{
-  queryMolecule(token, description);
-}
-
-template <> void Dialog::query< std::vector<const molecule *> >(const char *token, std::string description)
-{
-  queryMolecules(token, description);
-}
-
-template <> void Dialog::query<Vector>(const char *token, std::string description)
-{
-  queryVector(token, false, description);
-}
-
-template <> void Dialog::query< std::vector<Vector> >(const char *token, std::string description)
-{
-  queryVectors(token, false, description);
-}
-
-template <> void Dialog::query<BoxVector>(const char *token, std::string description)
-{
-  queryVector(token, true, description);
-}
-
-template <> void Dialog::query< std::vector<BoxVector> >(const char *token, std::string description)
-{
-  queryVectors(token, true, description);
-}
-
-template <> void Dialog::query<Box>(const char *token, std::string description)
-{
-  queryBox(token, description);
-}
-
-template <> void Dialog::query<const element *>(const char *token, std::string description)
-{
-  queryElement(token, description);
-}
-
-template <> void Dialog::query< std::vector<const element *> >(const char *token, std::string description)
-{
-  queryElements(token, description);
-}
-
-template <> void Dialog::query< boost::filesystem::path >(const char *token, std::string description)
-{
-  queryFile(token, description);
-}
-
-template <> void Dialog::query< std::vector<boost::filesystem::path> >(const char *token, std::string description)
-{
-  queryFiles(token, description);
-}
-
-template <> void Dialog::query< RandomNumberDistribution_Parameters >(const char *token, std::string description)
-{
-  queryRandomNumberDistribution_Parameters(token, description);
+template <> void Dialog::query<bool>(Parameter<bool> &param, const char *token, std::string description)
+{
+  queryBoolean(param, token, description);
+}
+
+template <> void Dialog::query<int>(Parameter<int> &param, const char *token, std::string description)
+{
+  queryInt(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<int> >(Parameter<std::vector<int> > &param, const char *token, std::string description)
+{
+  queryInts(param, token, description);
+}
+
+template <> void Dialog::query<unsigned int>(Parameter<unsigned int> &param, const char *token, std::string description)
+{
+  queryUnsignedInt(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<unsigned int> >(Parameter<std::vector<unsigned int> > &param, const char *token, std::string description)
+{
+  queryUnsignedInts(param, token, description);
+}
+
+template <> void Dialog::query<double>(Parameter<double> &param, const char *token, std::string description)
+{
+  queryDouble(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<double> >(Parameter<std::vector<double> > &param, const char *token, std::string description)
+{
+  queryDoubles(param, token, description);
+}
+
+template <> void Dialog::query<std::string>(Parameter<std::string> &param, const char *token, std::string description)
+{
+  queryString(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<std::string> >(Parameter<std::vector<std::string> > &param, const char *token, std::string description)
+{
+  queryStrings(param, token, description);
+}
+
+template <> void Dialog::query<const atom *>(Parameter<const atom *> &param, const char *token, std::string description)
+{
+  queryAtom(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<const atom *> >(Parameter<std::vector<const atom *> > &param, const char *token, std::string description)
+{
+  queryAtoms(param, token, description);
+}
+
+template <> void Dialog::query<const molecule *>(Parameter<const molecule *> &param, const char *token, std::string description)
+{
+  queryMolecule(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<const molecule *> >(Parameter<std::vector<const molecule *> > &param, const char *token, std::string description)
+{
+  queryMolecules(param, token, description);
+}
+
+template <> void Dialog::query<Vector>(Parameter<Vector> &param, const char *token, std::string description)
+{
+  queryVector(param, token, false, description);
+}
+
+template <> void Dialog::query< std::vector<Vector> >(Parameter<std::vector<Vector> > &param, const char *token, std::string description)
+{
+  queryVectors(param, token, false, description);
+}
+
+template <> void Dialog::query<BoxVector>(Parameter<BoxVector> &param, const char *token, std::string description)
+{
+  ASSERT(0, "TODO: query<BoxVector>");
+  //queryVector(param, token, true, description);
+}
+
+template <> void Dialog::query< std::vector<BoxVector> >(Parameter<std::vector<BoxVector> > &param, const char *token, std::string description)
+{
+  ASSERT(0, "TODO: query<vector<BoxVector> >");
+  //queryVectors(param, token, true, description);
+}
+
+template <> void Dialog::query<RealSpaceMatrix>(Parameter<RealSpaceMatrix> &param, const char *token, std::string description)
+{
+  queryRealSpaceMatrix(param, token, description);
+}
+
+template <> void Dialog::query<const element *>(Parameter<const element *> &param, const char *token, std::string description)
+{
+  queryElement(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<const element *> >(Parameter<std::vector<const element *> > &param, const char *token, std::string description)
+{
+  queryElements(param, token, description);
+}
+
+template <> void Dialog::query< boost::filesystem::path >(Parameter<boost::filesystem::path> &param, const char *token, std::string description)
+{
+  queryFile(param, token, description);
+}
+
+template <> void Dialog::query< std::vector<boost::filesystem::path> >(Parameter<std::vector< boost::filesystem::path> > &param, const char *token, std::string description)
+{
+  queryFiles(param, token, description);
+}
+
+template <> void Dialog::query< RandomNumberDistribution_Parameters >(Parameter<RandomNumberDistribution_Parameters> &param, const char *token, std::string description)
+{
+  queryRandomNumberDistribution_Parameters(param, token, description);
 }
 
